/*
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
"use strict";function cwt(r,t,a,e,n,o,f,u){var h=r.length;void 0===a&&(a=!0),void 0===n&&(n=2*t),void 0===e&&(e=.25),void 0===o&&(o=Math.ceil(Math.log2(h*t/n)/e));var i=mean(r),s=r.map(function(r){return r-i});if(a){var v=Math.ceil(Math.log2(h));1<<v===h&&(v+=1);for(var c=(1<<v)-h,p=0;p<c;p++)s.push(0)}for(var M=s.length,d=Math.floor(M/2),l=[],p=0;p<M;p++)l.push(0);for(var m=[0],p=1;p<=d;p++)m.push(p*(2*Math.PI/(M*t)));for(var p=d-1;p>=1;p--)m.push(-m[p]);fft.transform(s,l);for(var g=[],p=0;p<=o;p++)g.push(n*Math.pow(2,p*e));for(var w,q=[],_=0;_<=o;_++){w=wave_bases(f,m,g[_]);var x=w.daughter.map(function(r,t,a){return r*s[t]}),I=w.daughter.map(function(r,t,a){return r*l[t]});fft.inverseTransform(x,I);for(var c=[],p=0;p<h;p++)c.push(Math.sqrt(x[p]*x[p]+I[p]*I[p]));q.push(c)}for(var P=g.map(function(r){return w.fourier_factor*r}),b=P.map(function(r){return 1/r}),y=w.coi*t,T=[1e-5*y],j=(h+1>>1)-1,p=1;p<=j;p++)T.push(p*y);for(var p=(h>>1)-1;p>=1;p--)T.push(p*y);for(var k=s,z=l,A=0;A<h;A++)k[A]=Math.sqrt(k[A]*k[A]+z[A]*z[A])/h;return T.push(1e-5*y),{period:P,scale:g,freq:b,coi:T,fftr:s,ffti:l,fftmag:k,wave:q.reverse()}}var mean=function(r){return r.reduce(function(r,t,a,e){return r+t},0)/r.length},amp=function(r,t){for(var a=[],e=0;e<r.length;e++)a.push(Math.sqrt(r[e]*r[e]+t[e]*t[e]));return a},wave_bases=function(r,t,a,e){var n=t.length;void 0===e&&(e=6);var o=e,f=Math.sqrt(a*t[1])*Math.pow(Math.PI,-.25)*Math.sqrt(n),u=t.map(function(r){if(r>0){var t=-Math.pow(a*r-o,2)/2;return f*Math.exp(t)}return 0}),h=4*Math.PI/(o+Math.sqrt(2+o*o)),i=h/Math.sqrt(2),s=2;return{daughter:u,fourier_factor:h,coi:i,dofmin:s}},cwavelet="undefined"==typeof exports?function(){}:exports;cwavelet.cwt=cwt;